/*
 * Copyright 2014 Red Hat, Inc.
 *
 * Red Hat licenses this file to you under the Apache License, version 2.0
 * (the "License"); you may not use this file except in compliance with the
 * License.  You may obtain a copy of the License at:
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

package io.vertx.reactivex.codegen.testmodel;

import io.vertx.reactivex.RxHelper;
import io.vertx.reactivex.ObservableHelper;
import io.vertx.reactivex.FlowableHelper;
import io.vertx.reactivex.impl.AsyncResultMaybe;
import io.vertx.reactivex.impl.AsyncResultSingle;
import io.vertx.reactivex.impl.AsyncResultCompletable;
import io.vertx.reactivex.WriteStreamObserver;
import io.vertx.reactivex.WriteStreamSubscriber;
import java.util.Map;
import java.util.Set;
import java.util.List;
import java.util.Iterator;
import java.util.function.Function;
import java.util.stream.Collectors;
import io.vertx.core.Handler;
import io.vertx.core.AsyncResult;
import io.vertx.core.json.JsonObject;
import io.vertx.core.json.JsonArray;
import io.vertx.lang.rx.RxGen;
import io.vertx.lang.rx.TypeArg;
import io.vertx.lang.rx.MappingIterator;

/**
 *
 * <p/>
 * NOTE: This class has been automatically generated from the {@link io.vertx.codegen.testmodel.InterfaceWithStringArg original} non RX-ified interface using Vert.x codegen.
 */

@RxGen(io.vertx.codegen.testmodel.InterfaceWithStringArg.class)
public class InterfaceWithStringArg extends io.vertx.reactivex.codegen.testmodel.GenericRefedInterface<java.lang.String> {

  @Override
  public String toString() {
    return delegate.toString();
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    InterfaceWithStringArg that = (InterfaceWithStringArg) o;
    return delegate.equals(that.delegate);
  }
  
  @Override
  public int hashCode() {
    return delegate.hashCode();
  }

  public static final TypeArg<InterfaceWithStringArg> __TYPE_ARG = new TypeArg<>(    obj -> new InterfaceWithStringArg((io.vertx.codegen.testmodel.InterfaceWithStringArg) obj),
    InterfaceWithStringArg::getDelegate
  );

  private final io.vertx.codegen.testmodel.InterfaceWithStringArg delegate;
  
  public InterfaceWithStringArg(io.vertx.codegen.testmodel.InterfaceWithStringArg delegate) {
    super(delegate);
    this.delegate = delegate;
  }

  public InterfaceWithStringArg(Object delegate) {
    super((io.vertx.codegen.testmodel.InterfaceWithStringArg)delegate);
    this.delegate = (io.vertx.codegen.testmodel.InterfaceWithStringArg)delegate;
  }

  public io.vertx.codegen.testmodel.InterfaceWithStringArg getDelegate() {
    return delegate;
  }


  public io.vertx.reactivex.codegen.testmodel.GenericRefedInterface<java.lang.String> setValue(java.lang.String value) { 
    delegate.setValue(value);
    return this;
  }

  public java.lang.String getValue() { 
    java.lang.String ret = delegate.getValue();
    return ret;
  }

  public void meth() { 
    delegate.meth();
  }

  public static InterfaceWithStringArg newInstance(io.vertx.codegen.testmodel.InterfaceWithStringArg arg) {
    return arg != null ? new InterfaceWithStringArg(arg) : null;
  }

}
