/*
 * Copyright 2014 Red Hat, Inc.
 *
 * Red Hat licenses this file to you under the Apache License, version 2.0
 * (the "License"); you may not use this file except in compliance with the
 * License.  You may obtain a copy of the License at:
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

package io.vertx.reactivex.codegen.testmodel;

import io.vertx.reactivex.RxHelper;
import io.vertx.reactivex.ObservableHelper;
import io.vertx.reactivex.FlowableHelper;
import io.vertx.reactivex.impl.AsyncResultMaybe;
import io.vertx.reactivex.impl.AsyncResultSingle;
import io.vertx.reactivex.impl.AsyncResultCompletable;
import io.vertx.reactivex.WriteStreamObserver;
import io.vertx.reactivex.WriteStreamSubscriber;
import java.util.Map;
import java.util.Set;
import java.util.List;
import java.util.Iterator;
import java.util.function.Function;
import java.util.stream.Collectors;
import io.vertx.core.Handler;
import io.vertx.core.AsyncResult;
import io.vertx.core.json.JsonObject;
import io.vertx.core.json.JsonArray;
import io.vertx.lang.rx.RxGen;
import io.vertx.lang.rx.TypeArg;
import io.vertx.lang.rx.MappingIterator;

/**
 *
 * <p/>
 * NOTE: This class has been automatically generated from the {@link io.vertx.codegen.testmodel.InterfaceWithVariableArg original} non RX-ified interface using Vert.x codegen.
 */

@RxGen(io.vertx.codegen.testmodel.InterfaceWithVariableArg.class)
public class InterfaceWithVariableArg<T,U> extends io.vertx.reactivex.codegen.testmodel.GenericRefedInterface<U> {

  @Override
  public String toString() {
    return delegate.toString();
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    InterfaceWithVariableArg that = (InterfaceWithVariableArg) o;
    return delegate.equals(that.delegate);
  }
  
  @Override
  public int hashCode() {
    return delegate.hashCode();
  }

  public static final TypeArg<InterfaceWithVariableArg> __TYPE_ARG = new TypeArg<>(    obj -> new InterfaceWithVariableArg((io.vertx.codegen.testmodel.InterfaceWithVariableArg) obj),
    InterfaceWithVariableArg::getDelegate
  );

  private final io.vertx.codegen.testmodel.InterfaceWithVariableArg<T,U> delegate;
  public final TypeArg<T> __typeArg_0;
  public final TypeArg<U> __typeArg_1;
  
  public InterfaceWithVariableArg(io.vertx.codegen.testmodel.InterfaceWithVariableArg delegate) {
    super(delegate);
    this.delegate = delegate;
    this.__typeArg_0 = TypeArg.unknown();    this.__typeArg_1 = TypeArg.unknown();  }

  public InterfaceWithVariableArg(Object delegate, TypeArg<T> typeArg_0, TypeArg<U> typeArg_1) {
    super((io.vertx.codegen.testmodel.InterfaceWithVariableArg)delegate);
    this.delegate = (io.vertx.codegen.testmodel.InterfaceWithVariableArg)delegate;
    this.__typeArg_0 = typeArg_0;
    this.__typeArg_1 = typeArg_1;
  }

  public io.vertx.codegen.testmodel.InterfaceWithVariableArg getDelegate() {
    return delegate;
  }


  public io.vertx.reactivex.codegen.testmodel.GenericRefedInterface<U> setValue(U value) { 
    delegate.setValue(__typeArg_1.<U>unwrap(value));
    return this;
  }

  public U getValue() { 
    U ret = (U)__typeArg_1.wrap(delegate.getValue());
    return ret;
  }

  public void setOtherValue(T value) { 
    delegate.setOtherValue(__typeArg_0.<T>unwrap(value));
  }

  public T getOtherValue() { 
    T ret = (T)__typeArg_0.wrap(delegate.getOtherValue());
    return ret;
  }

  public static <T,U> InterfaceWithVariableArg<T,U> newInstance(io.vertx.codegen.testmodel.InterfaceWithVariableArg arg) {
    return arg != null ? new InterfaceWithVariableArg<T,U>(arg) : null;
  }

  public static <T,U> InterfaceWithVariableArg<T,U> newInstance(io.vertx.codegen.testmodel.InterfaceWithVariableArg arg, TypeArg<T> __typeArg_T, TypeArg<U> __typeArg_U) {
    return arg != null ? new InterfaceWithVariableArg<T,U>(arg, __typeArg_T, __typeArg_U) : null;
  }

}
