/*
 * Copyright 2014 Red Hat, Inc.
 *
 * Red Hat licenses this file to you under the Apache License, version 2.0
 * (the "License"); you may not use this file except in compliance with the
 * License.  You may obtain a copy of the License at:
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

package io.vertx.reactivex.codegen.testmodel;

import io.vertx.reactivex.RxHelper;
import io.vertx.reactivex.ObservableHelper;
import io.vertx.reactivex.FlowableHelper;
import io.vertx.reactivex.impl.AsyncResultMaybe;
import io.vertx.reactivex.impl.AsyncResultSingle;
import io.vertx.reactivex.impl.AsyncResultCompletable;
import io.vertx.reactivex.WriteStreamObserver;
import io.vertx.reactivex.WriteStreamSubscriber;
import java.util.Map;
import java.util.Set;
import java.util.List;
import java.util.Iterator;
import java.util.function.Function;
import java.util.stream.Collectors;
import io.vertx.core.Handler;
import io.vertx.core.AsyncResult;
import io.vertx.core.json.JsonObject;
import io.vertx.core.json.JsonArray;
import io.vertx.lang.rx.RxGen;
import io.vertx.lang.rx.TypeArg;
import io.vertx.lang.rx.MappingIterator;

/**
 *
 * <p/>
 * NOTE: This class has been automatically generated from the {@link io.vertx.codegen.testmodel.RefedInterface1 original} non RX-ified interface using Vert.x codegen.
 */

@RxGen(io.vertx.codegen.testmodel.RefedInterface1.class)
public class RefedInterface1 {

  @Override
  public String toString() {
    return delegate.toString();
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    RefedInterface1 that = (RefedInterface1) o;
    return delegate.equals(that.delegate);
  }
  
  @Override
  public int hashCode() {
    return delegate.hashCode();
  }

  public static final TypeArg<RefedInterface1> __TYPE_ARG = new TypeArg<>(    obj -> new RefedInterface1((io.vertx.codegen.testmodel.RefedInterface1) obj),
    RefedInterface1::getDelegate
  );

  private final io.vertx.codegen.testmodel.RefedInterface1 delegate;
  
  public RefedInterface1(io.vertx.codegen.testmodel.RefedInterface1 delegate) {
    this.delegate = delegate;
  }

  public RefedInterface1(Object delegate) {
    this.delegate = (io.vertx.codegen.testmodel.RefedInterface1)delegate;
  }

  public io.vertx.codegen.testmodel.RefedInterface1 getDelegate() {
    return delegate;
  }

  public java.lang.String getString() { 
    java.lang.String ret = delegate.getString();
    return ret;
  }

  public io.vertx.reactivex.codegen.testmodel.RefedInterface1 setString(java.lang.String str) { 
    delegate.setString(str);
    return this;
  }

  public static RefedInterface1 newInstance(io.vertx.codegen.testmodel.RefedInterface1 arg) {
    return arg != null ? new RefedInterface1(arg) : null;
  }

}
